;------------------------------------------------------------------------------
$Debug=0
;------------------------------------------------------------------------------

opt("TrayIconDebug",$Debug)
opt("TrayIconHide",$Debug=0)

;Exec("devcon.exe remove ""umpport\VID_0451_3410_com""")
;Exec("devcon.exe remove ""USB\Vid_0451&Pid_3410""")

;------------------------------------------------------------------------------
;Delete INF/Treiber Files
;------------------------------------------------------------------------------
FileSetAttrib(@SystemDir  & "\drivers\umpf3410.i51","-RSH")
FileDelete   (@SystemDir  & "\drivers\umpf3410.i51")
FileSetAttrib(@SystemDir  & "\drivers\umpusbxp.sys","-RSH")
FileDelete   (@SystemDir  & "\drivers\umpusbxp.sys")
FileSetAttrib(@WindowsDir & "\inf\umpusbXP.inf","-RSH")
FileDelete   (@WindowsDir & "\inf\umpusbXP.inf")
FileSetAttrib(@WindowsDir & "\inf\UmpComXP.inf","-RSH")
FileDelete   (@WindowsDir & "\inf\UmpComXP.inf")
FileSetAttrib(@WindowsDir & "\inf\umpusbXP.pnf","-RSH")
FileDelete   (@WindowsDir & "\inf\umpusbXP.pnf")
FileSetAttrib(@WindowsDir & "\inf\UmpComXP.pnf","-RSH")
FileDelete   (@WindowsDir & "\inf\UmpComXP.pnf")

;------------------------------------------------------------------------------
;Delete Devices
;------------------------------------------------------------------------------

$DrvKey="HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Enum\USB\VID_0451&PID_3410"
$ComDrvKey="HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Enum\umpport\com\"
$ClassKey="HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Class\"

While 1
  $SubKeyName=RegEnumKey($DrvKey,1)
  If ($SubKeyName="") Then ExitLoop
  $ParentIdPrefix=RegRd($DrvKey & "\" & $SubKeyName,"ParentIdPrefix")
  If ($ParentIdPrefix<>"") Then
    $Driver=RegRd($ComDrvKey & $ParentIdPrefix & "&0000","Driver")
    If ($Driver<>"") Then RegDel($ClassKey & $Driver)
    RegDel($ComDrvKey & $ParentIdPrefix & "&0000")
  EndIf
  $Driver=RegRd($DrvKey & "\" & $SubKeyName,"Driver")
  If ($Driver<>"") Then RegDel($ClassKey & $Driver)
  RegDel($DrvKey & "\" & $SubKeyName)
Wend

RegDel("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\UsbFlags\045134100100")
RegDel("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\umpusbxp")
RegDel($DrvKey)
RegDel("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Enum\umpport")


;------------------------------------------------------------------------------
;Delete DeviceClasses
;------------------------------------------------------------------------------
$Index=1
$KeyName="HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\DeviceClasses\{4d36e978-e325-11ce-bfc1-08002be10318}"
While 1
  $SubKeyName=RegEnumKey($KeyName,$Index)
  If ($SubKeyName="") Then ExitLoop
  If (StringLeft($SubKeyName,15)="##?#umpport#com") Then 
    RegDel($KeyName & "\" & $SubKeyName)
  Else
    $Index=$Index+1
  EndIf
Wend

$Index=1
$KeyName="HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\DeviceClasses\{a5dcbf10-6530-11d2-901f-00c04fb951ed}"
While 1
  $SubKeyName=RegEnumKey($KeyName,$Index)
  If ($SubKeyName="") Then ExitLoop
  If (StringLeft($SubKeyName,25)="##?#USB#Vid_0451&Pid_3410") Then 
    RegDel($KeyName & "\" & $SubKeyName)
  Else
    $Index=$Index+1
  EndIf
Wend

Exit

Func RegDel($What)
  Exec("SubInACL.exe /subkeyreg """ & $What & """ /setowner=S-1-5-32-544") 
  Exec("SubInACL.exe /subkeyreg """ & $What & """ /grant=S-1-5-32-544=F") 
  $Delval=RegDelete($What)
  If ($Debug=1) Then
    If ($DelVal=0) Then 
      MsgBox(0,"AutoIt: RegDel Error","Registry Key """ & $What & """ does not exist!") 
    ElseIf ($DelVal=2) Then 
      MsgBox(0,"AutoIt: RegDel Error","Failed deleting Registry Key """ & $What & """") 
    Else
      MsgBox(0,"AutoIt: RegDel","Registry Key """ & $What & """ deleted") 
    EndIf
  EndIf
  Return $Delval
EndFunc

Func RegRd($What,$Value)
  $Val=RegRead($What,$Value)
  If ($Debug=1) Then
    If ($Val="") Then
      If (@error= 1) Then 
        MsgBox(0,"AutoIt: RegRd Error","Registry Key """ & $What & """ does not exist!") 
      ElseIf (@error=-1) Then 
        MsgBox(0,"AutoIt: RegRd Error","Registry Value """ & $Value & """ in Key """ & $What & """does not exist!") 
      ElseIf (@error=-2) Then 
        MsgBox(0,"AutoIt: RegRd Error","Registry Value type """ & $Value & """ in Key """ & $What & """not supported!") 
      EndIf
    Else
      MsgBox(0,"AutoIt: RegRd","Registry Value """ & $Value & """ in Key """ & $What & """ == """ & $Val & """") 
    EndIf
  EndIf
  Return $Val
EndFunc

Func Exec($CMD)
  If ($Debug=1) Then
    RunWait(@ComSpec & " /K " & $CMD)
  Else
    RunWait(@ComSpec & " /C " & $CMD,@WorkingDir,@SW_HIDE)
  EndIf
EndFunc